#if linux
	typedef T = TTSUbuntu
#elseif  android
	typedef T = TTSAndroid;
#end 


class TTS
{

	/**
	*	Close Engine
	*/
	public static function closeEngine():Void
	{
		T.closeEngine();
	}

	/**
	*	Stop Engine
	*/
	public static function stopEngine():Void
	{
		T.stopEngine();
	}


	/**
	*  Flush text speech engine and make it pronounce text
	*/
	public static function sayText(textToSay:String, choice:Int, idString:String=""):Void
	{
		trace("say  " + textToSay);
		T.sayText(textToSay, choice, idString);
	}

	/**
	*	TODO Check if mobile has TTS engine, if not propose to install
	*/
	public static function checkHasTTS():Void
	{
		T.checkHasTTS();
	}

	/**
	*   Set locale or language of TTS
	*/
	public static function setLanguageLocale(lang_variant:Int, lang:Int, lang_locale:String):Void
	{
		T.setLanguageLocale(lang_variant, lang, lang_locale);
	}

	/**
	*	Set Pitch of TTS, 1 is default
	*/
	public static function setPitch(pitch:Float):Void
	{
		T.setPitch(pitch);
	}

	/*
	*	Set Speech Rate of TTS, 1 is default
	*/
	public static function setSpeechRate(speechRate:Float):Void
	{
		T.setSpeechRate(speechRate);
	}

	/**
	*   Checks if TTS is speaking
	*/
	public static function isSpeaking():Bool
	{
		return T.isSpeaking();
	}

	/**
	*	Check all available locale languages for initialised TTS engine
	*/
	public static function getLangAvailable(choice:Int):Array<Dynamic>
	{
		return T.getLangAvailable(choice);
	}

	/**
	*	Get actual language
	*/
	public static function getLang():String 
	{
		return T.getLang();
	}



	/**
	*	Check all installed engines
	*   From Api 14
	*/
	public static function getInstalledEngines():Array<Dynamic>
	{
		return T.getInstalledEngines();
	}

    /**
    *	Add Earcon, mapping between string of text and sound file
    */
    public static function addEarcon(soundName:String, soundPath:String):Void
    {
    	T.addEarcon(soundName, soundPath);
    }

    /**
    *	Adds earcon to queue
    */
    public static function playEarcon(soundName:String):Void
    {
    	T.playEarcon(soundName);
    }

    /**
    *
    */
    public static function synthetiseToFile(text:String, location:Int, folder:String, filename:String):Void
    {
    	T.synthetiseToFile(text, location, folder, filename);
    }
 }