import com.stencyl.utils.Utils;

class Phonetic_WindowsUPS
{

// UPS ( Universal Phone set) A machine-readable phonetic notation created by Microsof

// Only the consonnants, vowels used in French and English
// 
    
	public static var sortedUPS:Array<Dynamic> = new Array();

	public static function getSortedUPS()
	{
		if (sortedUPS.length == 0)
		{
			sortedUPS = Utils.mapToList(xSampaToUPS, "keys");
			sortedUPS.sort(function(a:String, b:String):Int {
  			if (a.length < b.length) {
    			return 1;
  			}
  			else if (a.length > b.length) {
    			return -1;
  				} else {
    			return 0;
  			}
			});
		}

		return sortedUPS;
	}

	public static function convertFromXSampa(xSampa:String)
	{
		var transcription:String = "";
		var pos:Int = 0;

		var sorted = getSortedUPS();

		while (pos < xSampa.length)
		{
			var hasFoundXSampa:Bool = false;
			for (xs in sorted)
			{
				if (xs == xSampa.substr(pos, xs.length))
				{
					hasFoundXSampa = true;
					transcription = transcription + xSampaToUPS.get(xs) + " ";
					// should check if vowel for stress
					pos += xs.length;
					break;
				}

			}
			if (!hasFoundXSampa)
			{
				++pos;
			}


		}

		trace("transcription : " + xSampa + " to " + transcription);
		return transcription;
	}



	public static var xSampaToUPS:Map<String,String> =
	[
		// Consonnant Phones
	"p" => "P",  // En put 
	"b" => "B",  // En big
	"m" => "M",  // En mat
	"f" => "F",  // En fork
	"v" => "V",  // En vat
	"T" => "TH", // En thin
	"D" => "DH", // En then 
	"t" => "T", // En talk
	"d" => "D", // En dig
	"n" => "N",  // En no
	"4" => "DX",    // US butter
	"s" => "S",     // US sit
	"z" => "Z",     // US zap
	"l" => "L",     // US lip
	"S" => "SH",    // US she
	"Z" => "ZH",    // US pleasure
	"r" => "R",     // US red
	"J" => "NJ",    // Fr oignon
	"j" => "J",    // US yard 
	"w" => "W",     // US with
	"k" => "K",     // US cut
	"g" => "G",     // US gut
	"N" => "NG",    // US sing
	"R" => "RH",    // Fr rond
	"h" => "H",     // US help
	"H" => "WJ",    // Fr huit

	"tS" => "CH",   // En chin
	"dZ" => "DZ",   // En joy
	"a" => "A", 
	"i" => "i",     // En feel
	"y" => "Y",     // Fr du
	"u" => "u",     // En too
	"I" => "IH",    // En fill
	"U" => "UH",    // En book
	"e" => "E",     // Fr ses
	"o" => "O",     // En go
	"@" => "AX",    // En ago
	"E" => "EH",    // En pet
	"3" => "ER",    // GB bird
	"V" => "AH",    // En cut
	"O" => "AO",    // En dog
	"{" => "AE",    // En cat
	"A" => "AA",    // En father
	"Q" => "Q",    // En hot

	// diphtong

	"eI" => "EI",    // En late
	"aU" => "AU",    // En foul
	"OI" => "OI",    // En toy
	"AI" => "AI",    // En bite
	"i@" => "IYX",   // En fear
	"E@" => "EHX",   // En stairs
	"u@" => "UWX",   // En lure
	"o@" => "OWX",   // En boa
	"O@" => "AOX",   // En four

	// Nasal

	"E~" => "E nas",  // Fr vin
	"A~" => "A nas",  // Fr vent
	"O~" => "O nas",  // Fr bon
	"9~" => "OE nas" // Fr brun
	];




}
