package;
import haxe.PosInfos;
import Sys;
import haxe.io.Eof;
import openfl.Lib;

import haxe.io.BytesOutput;
import com.stencyl.Engine;
import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.TimedTask;
//using thx.Strings;

#if linux
import TTSUbuntu as T;
#elseif (windows&&cppia)
import TTSWindows as T;
#elseif (android&&cppia)
import TTSAndroid as T;
#elseif flash
import TTSFlash as T;
#elseif windows
import TTSWindows as T;
#elseif android
import TTSAndroid as T;
#elseif js
import TTSWeb as T;
#elseif mac
import TTSMac as T;
#end




class TTS
{	
	
	public static var tTSLastSaidId:String = "";

	/**
	*	Close Engine
	*/
	public static function closeEngine():Void
	{
		#if android
		T.closeEngine();
		#end
	}

	/**
	*	Stop Engine
	*/
	public static function stopEngine():Void
	{
		#if android
		T.stopEngine();
		#end
	}

	/**
	*  Pronounce text
	*/
	public static function sayText(textToSay:String,choice:Int,idString:String="", ?pos : PosInfos):Void
	{
		T.sayText(textToSay,choice,idString);
	}
	
	/**
	 *  String for XSAMPA so that it can be pronounced by TTS
	 */
	public static function adaptedXSAMPAString(s:String):String
	{
		#if (linux || android || windows || cppia)
			return T.adaptedXSAMPAString(s);
		#else
			return s;
		#end
	}
	
	/**
	 *  Check if supports XSAMPA
	 */
	
	public static function hasXSAMPASupport():Bool
	{
		#if (linux || android || windows || cppia) 
			return T.hasXSAMPASupport();
		#else
			return false;
		#end
	}
	
	/**
	*	TODO check if has TTS engine,if not propose to install
	*/
	public static function checkHasTTS():Void
	{
		#if (linux || android || windows || cppia)
		T.checkHasTTS();
		#end
	}

	/**
	*   Set locale or language of TTS
	*/
	public static function setLanguageLocale(lang_variant:Int,lang:Int,lang_locale:String):Void	
	{
		T.setLanguageLocale(lang_variant,lang,lang_locale);
	}

	/**
	*	Set Pitch of TTS,1 is default
	*/
	public static function setPitch(f:Float):Void
	{
		#if (linux || android)
		T.setPitch(f);
		#end
	}

	/*
	*	Set Speech Rate of TTS,1 is default
	*/
	public static function setSpeechRate(f:Float):Void
	{
		#if (linux || android)
		T.setSpeechRate(f);
		#end
		
	}

	/**
	*   Checks if TTS is speaking
	*/
	public static function isSpeaking():Bool
	{
		#if (linux || android)
		return T.isSpeaking();
		#else
		trace("isSpeaking Flash");
		return false;
		#end
	}

	/**
	*	Check all available locale languages for initialised TTS engine
	*/
	public static function getLangAvailable(choice:Int):Array<Dynamic>
	{
		#if (linux || android)
		return T.getLangAvailable(choice);
		#else
		return ["en"];
		#end

	}

	/**
	*	Get actual language
	*/
	public static function getLang():String 
	{
		#if (linux || android)
		return T.getLang();
		#else
		return "en";
		#end
	}



	/**
	*	Check all installed engines
	*   
	*/
	public static function getInstalledEngines():Array<Dynamic>
	{
		#if (linux || android)
		return T.getInstalledEngines();
		#else
		return [];
		#end

		
	}

	/**
	*	Add Earcon,mapping between string of text and sound file
	*/
	public static function addEarcon(soundName:String,soundPath:String):Void
	{
		#if (linux || android)
		T.addEarcon(soundName,soundPath);
		#end
	}

	/**
	*	Adds earcon to queue
	*/
	public static function playEarcon(soundName:String):Void
	{
		#if (linux || android)
		T.playEarcon(soundName);
		#end
		
	}

	/**
	*
	*/
	public static function synthetiseToFile(text:String,location:Int,folder:String,filename:String):Void
	{
		#if (linux || android)
		T.synthetiseToFile(text,location,folder,filename);
		#end
	}

	public function new()
	{
	}



 }
