package;


import Sys;
import haxe.io.Eof;
import openfl.Lib;

import haxe.io.BytesOutput;
import com.stencyl.Engine;
import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.TimedTask;

class TTSUbuntu
{	
	
	public static var debug: Bool	= false;	// TODO Haxe flag
	
	public static var eSpeaking:Bool= false;

	public static var queueTTS: String = "queueTTS"; 
	
	public static var gap: Int = 10; // minimum gap between speeches can't be < 0 :) -g <integer>  Word gap. Pause between words, units of 10mS at the default speed
	public static var pitch: Int = 50;
	public static var rate : Int;
	public static var speed : Int = 125; // approximate speed in words per minute 
	public static var voice : String = "en";



	/// -------------Specific to espeak -----------------------//

	public static function eSpeakCommand(textToSay: String ) : String
	{
		var voice = getLang();																			
		return  'texto="' +  TTSUtils.quoteEsc(textToSay)  + '";' +  "echo $texto" + "| /usr/bin/espeak --stdin -s " + rate + " -p "+ pitch + " -g " + gap + " -v " + voice; 
	}
   
	public static inline function eSpeakCommandFile(textToSay: String,fileName:String): String
    {
    	if (fileName != "")
    	{
    		trace("eSpeakCommandFile" + textToSay + "_" + fileName);
    		return eSpeakCommand(textToSay) + " -w " + fileName ;
    	}
    	else
    	{
    		return eSpeakCommand(textToSay);
    	}
    }	

    /**
     * 
     */
    
    public static function synthetiseToFile(text:String, filename:String)
    {
    	// cmd will create the file if it doesn't exist		need trouble shooting TODO				// see notes Quoting for the use of $ in  $textToSay
		cmd = eSpeakCommandFile(text, filename) ;			// mind the spaces and the $
				// can be quicker but difficult to read

		// execute the command write
		Sys.command(cmd);		
    }

    /**
    	play recorded sound    	
    */
    public static function playSound(filename:String)
    {
    	var cmd = "/usr/bin/play";              
		var args = [filename]; // later other arguments
		var play: sys.io.Process;
		play = new sys.io.Process(cmd,args);

		return play;
    }
    
    
	/**
	*  Pronounce text
	*  if choice = 0, flush
	*  if choice = 1, add
	*/
	public static function sayText(textToSay:String, choice:Int, idString:String=""):Void
	{
			
		if ( (textToSay!="") ) 
		{					
			var soxi			: sys.io.Process;
			var tempTTSName		: String								= "tempTTS_" + idString + ".wav";		// use to record the actual speech, the dot is necessary t please sox
			var cmd				: String;																		// use to issue the shell commands
			var args			: Array<String>;																// arguments of the commands
			// var directory	:String = Sys.getCwd(); 														// used as a reminder .. no need to change that ? write in Assets ? on USB ?
			var play			: sys.io.Process;
			var lsof			: sys.io.Process;																// use to check if a file is busy
			var isnotBusyS		: String								= "wait" ;								// to read the buffer in order to know if a file is busy not a goodname, it's a string, we want it empty

			
			if (textToSay!="")				// not much for an empty text 
			{
				if (choice == 0)
				{
					// should check if file is playing, if it's the case should close the process
				}

				if (choice == 1)
				{
					// TO DO
				}								
	
				synthetiseToFile(textToSay, tempTTSName);

				// get duration of the file that has been created
				soxi =  new sys.io.Process('/usr/bin/soxi', ["-D", "./" + tempTTSName]);
				var durationSec:Float = Std.parseFloat(soxi.stdout.readAll().toString()); // trouble shooting -> nan


				// we play the file
				
				play = playSound(tempTTSName);
				eSpeaking = true;

				runLater( 1000 * durationSec, function(timeTask:TimedTask):Void { //millliseconds for runLater
				// to be really sure we want to know if the file is still **playing**, (not reading the file !)
					// we have finished
					trace ("we have finished for " + textToSay);
					eSpeaking = false;
					finishedShouter(idString);
																}, null);
				}
			
			
			// cleaning time removed temporarly debugging
			// Sys.command("rm -v "+ (tempTTSName)); 	// here to prevent others  to interfer , more if earcons
			}
			else {
				trace ("we have finished for an empty textToSay !");
				eSpeaking = false;
				finishedShouter(idString);
			}
		}
	}

		/**
	 *  String for XSAMPA so that it can be pronounced by TTS
	 */
	public static function adaptedXSAMPAString(s:String):String
	{
		return adaptedText = "[[" + PhonemeTranscription.xSampaToKirshenBaum(xSampa) + "]]";
	}
	
	/**
	 *  Check if supports XSAMPA
	 */
	
	public static function hasXSAMPASupport():Bool
	{
		return true;
	}
	
	/**
	*	TODO check if has TTS engine, if not propose to install	*/
	public static function checkHasTTS():Void
	{
	}

	/**
	*   Set locale or language of TTS
	*/
	public static function setLanguageLocale(lang_variant:Int, lang:Int, lang_locale:String):Void
		
	{
		//tempo discordance Android
		voice = lang_locale;
	}

	/**
	*	Set Pitch of TTS, 1 is default
	*/
	public static function setPitch(f:Float):Void
	{
		// -p <integer>   Pitch adjustment, 0 to 99, default is 50
		pitch = Std.int(f*50) ;
	}

	/*
	*	Set Speech Rate of TTS, 175 is  for espeak
	*/
	public static function setSpeechRate(f:Float):Void
	{
		// -s <integer>  Speed in approximate words per minute. The default is 175
		// too slow in French
		if ( (voice != "fr") ) {
		rate = Std.int(f*175);
		}
		else{
		rate = Std.int(f*190);
		}
		
	}

	/**
	*   Checks if TTS is speaking
	*/
	public static function isSpeaking():Bool
	{
		return eSpeaking;
	}

	/**
	*	Check all available locale languages for initialised TTS engine
	*/
	public static function getLangAvailable(choice:Int):Array<Dynamic>
	{
		return ["en", "fr", "sw"];

	}

	/**
	*	Get actual language
	*/
	public static function getLang():String 
	{
		return GlobalSettings.usedLanguage.iso;
	}



	/**
	*	Check all installed engines
	*   From Api 14
	*/
	public static function getInstalledEngines():Array<Dynamic>
	{
		return [];

		
	}

	/**
	*	Add Earcon, mapping between string of text and sound file
	*/
	public static function addEarcon(soundName:String, soundPath:String):Void
	{
	}

	/**
	*	Adds earcon to queue
	*/
	public static function playEarcon(soundName:String):Void
	{
	}

	/**
	*
	*/
	// public static function synthetiseToFile(text:String, location:Int, folder:String, filename:String):Void
	// {
 // 			case 0: savePath = mainContext.getFilesDir(); //Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOCUMENTS);      	// Default folder for documents
	// 				break;
	// 		case 1: savePath = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PODCASTS);  			// Default folder for podcasts
	// 				break;
	// 		case 2: savePath = mainContext.getFilesDir();  				// Local Directory
	// 				break;
	// 		case 3: savePath = mainContext.getCacheDir();  				//	Local Cache
	// 				break;
	// 		case 4: savePath = Environment.getExternalStorageDirectory(); 	// SD card
	// 				break;
	// 		default: savePath = mainContext.getCacheDir();
		 
	// }




	/**
	* 	
	*/
	public function new()
	{
	}



	/**
	*	 shouter when TTS finished processing
	*/

	public static function finishedShouter(text:String)
	{
		setGameAttribute("TTSLastSaidId", text);
		TTS.LastSaidId = TTS.tTSLastSaidId;
		shoutToScene("_customEvent_" + "TTSHasFinishedPlaying");
	}

	/**
	 *  shouter announcing TTS is loaded
	 */
	
	public static function TTSLoadedShouter()
	{
		shoutToScene("_customEvent_" + "TTSLoaded");
	}
	



 }