package;
import haxe.PosInfos;
import Sys;
import haxe.io.Eof;
import openfl.Lib;

import haxe.io.BytesOutput;
import com.stencyl.Engine;
import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.TimedTask;
//using thx.Strings;

#if js
import js.html.SpeechSynthesis;
import js.html.SpeechSynthesisUtterance;
import js.html.SpeechSynthesisVoice;
#end



class TTSWeb
{	
	public static var language:String = "";
	public static var voice:String = "";
	public static var synthesisVoice:Dynamic;
	private static var SPLIT_LINES = ~/\r\n|\n\r|\n|\r/g;


	public static var tTSLastSaidId:String = "";
	public static var currentId:String;

	/**
	*  Pronounce text
	*/
	public static function sayText(textToSay:String,choice:Int,idString:String="", ?pos : PosInfos):Void
	{

		currentId = idString;
		var text = textToSay;
		var ffffonction = finishedShouter.bind(idString);
		var code =
			" var msg = new SpeechSynthesisUtterance();
var voices = window.speechSynthesis.getVoices();
msg.voice = voices[10]; 
msg.voiceURI = 'native';
msg.volume = 1; 
msg.rate = 1; 
msg.pitch = 2; 
msg.text = text;
msg.lang = 'fr-FR';

msg.onend = function(e) {ffffonction()};

speechSynthesis.speak(msg);
";
		if (textToSay != "")
		{ 
			#if js
			js.Lib.eval(""+code);

			#end

			/*
			currentId = idString;
			var utt = new SpeechSynthesisUtterance();
			utt.voice = synthesisVoice;
			utt.onend = onend;
			utt.text = textToSay;
			trace(Reflect.fields(js.html.SpeechSynthesis));
			//js.html.SpeechSynthesis.speak(utt);
			*/
		}
	}

	public static function onend()
	{
		finishedShouter(currentId);
	}


	
	/**
	 *  String for XSAMPA so that it can be pronounced by TTS
	 */
	public static function adaptedXSAMPAString(s:String):String
	{
		var adaptedText:String;
		adaptedText = "<prosody volume=\"x-loud\"><phoneme alphabet=\"x-microsoft-ups\" ph=" + "'" + "S1 "+ Phonetic_WindowsUPS.convertFromXSampa(s) + "'"+ "/></prosody>";
		return adaptedText;
	}
	
	/**
	 *  Check if supports XSAMPA
	 */
	
	public static function hasXSAMPASupport():Bool
	{
		return true;
	}
	
	/**
	*	TODO check if has TTS engine,if not propose to install
	*/
	public static function checkHasTTS():Void
	{
		#if (linux || android)
		T.checkHasTTS();
		#end
	}

	/**
	*   Set locale or language of TTS
	*/
	public static function setLanguageLocale(lang_variant:Int,lang:Int,lang_locale:String):Void
		
	{
		var chosenOne:String ="";
		if ((lang_locale != null) && (lang_locale !=""))
		{
			chosenOne = lang_locale;
		} 
		if (chosenOne == "fr")
		{
			chosenOne = "fr-FR";
		}
		language = chosenOne;
		language = lang_locale;
		voice = language;

		/*
		var lookForWord = "";
		if (chosenOne == "fr")
		{
			lookForWord = "French";
		}
		else
		{
			lookForWord = "English";
		}*/

		
	}







	/**
	*	Set Pitch of TTS,1 is default
	*/
	public static function setPitch(f:Float):Void
	{
		#if (linux || android)
		T.setPitch(f);
		#end
	}

	/*
	*	Set Speech Rate of TTS,1 is default
	*/
	public static function setSpeechRate(f:Float):Void
	{
		#if (linux || android)
		T.setSpeechRate(f);
		#end
		
	}

	/**
	*   Checks if TTS is speaking
	*/
	public static function isSpeaking():Bool
	{
		#if (linux || android)
		return T.isSpeaking();
		#else
		trace("isSpeaking Flash");
		return false;
		#end
	}

	/**
	*	Check all available locale languages for initialised TTS engine
	*/
	public static function getLangAvailable(choice:Int):Array<Dynamic>
	{
		#if (linux || android)
		return T.getLangAvailable(choice);
		#else
		return ["en"];
		#end

	}

	/**
	*	Get actual language
	*/
	public static function getLang():String 
	{
		#if (linux || android)
		return T.getLang();
		#else
		return "en";
		#end
	}



	/**
	*	Check all installed engines
	*   
	*/
	public static function getInstalledEngines():Array<Dynamic>
	{

		//var voices = js.html.SpeechSynthesis.getVoices();

		return [];
		
	}

	/**
	*	Add Earcon,mapping between string of text and sound file
	*/
	public static function addEarcon(soundName:String,soundPath:String):Void
	{
		#if (linux || android)
		T.addEarcon(soundName,soundPath);
		#end
	}

	/**
	*	Adds earcon to queue
	*/
	public static function playEarcon(soundName:String):Void
	{
		#if (linux || android)
		T.playEarcon(soundName);
		#end
		
	}

	/**
	*
	*/
	public static function synthetiseToFile(text:String,location:Int,folder:String,filename:String):Void
	{
		#if (linux || android)
		T.synthetiseToFile(text,location,folder,filename);
		#end
	}

	public function new()
	{
	} 

    /**
	*	 shouter when TTS finished processing
	*/

	public static function finishedShouter(text:String)
	{
		setGameAttribute("TTSLastSaidId", text);
		TTS.tTSLastSaidId = text;
		shoutToScene("_customEvent_" + "TTSHasFinishedPlaying");
	}

 }
