package;
import haxe.PosInfos;
import Sys;
import haxe.io.Eof;
import openfl.Lib;

import haxe.io.BytesOutput;
import com.stencyl.Engine;
import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.TimedTask;
//using thx.Strings;





class TTSWindows
{	
	
	public static var voice:String = "";
	private static var SPLIT_LINES = ~/\r\n|\n\r|\n|\r/g;


	public static function saveSound(text:String, filename:String)
    {
    	var t :String = '<?xml version="1.0" encoding="ISO-8859-1"?> <speak version="1.0" xmlns="http://www.w3.org/2001/10/synthesis"
 xml:lang="'+ voice + '">' + text + '</speak>';
    	var iso:String ="";
    	try
    	{
    		iso = haxe.Utf8.decode(t);
    	}
    	catch(e:Dynamic)
    	{
    		iso = "";
    	}
    	trace(iso);
    	sys.io.File.saveContent(Sys.getCwd () + filename + ".txt", iso);
    	var cmd = Sys.getCwd () + "assets/tts.exe -f 10 -v " + voice +" -o " + filename + " -i "+ Sys.getCwd () + filename + ".txt ";  
    	//trace("text : " + text);
    	Sys.command(cmd);            
    }

    public static function saySound(idString:String)

    {
    	var file:String = Sys.getCwd () + idString + "0.wav"; 
        var nmeSound:openfl.media.Sound =  new openfl.media.Sound();
        var req:openfl.net.URLRequest = new openfl.net.URLRequest(file); 
        nmeSound.load(req);

        var stencylSound = new com.stencyl.models.Sound(-1, file, true, false, 0.0, 1.0, ".wav" #if (openfl>="6.0.0") ,0 #end);
		stencylSound.streaming = false;
		stencylSound.src = nmeSound;

		Script.playSound(stencylSound);

		return stencylSound;
    }



	public static var tTSLastSaidId:String = "";


	/**
	*  Pronounce text
	*/
	public static function sayText(textToSay:String,choice:Int,idString:String="", ?pos : PosInfos):Void
	{

		if (textToSay != "")
		{ 
			setVolumeForAllSounds(100/100);
			saveSound(textToSay, idString);
			var s = saySound(idString);
			var durationMs:Float = getSoundLength(s);

			runLater( durationMs, function(timeTask:TimedTask):Void { 
					finishedShouter(idString);
					try 
					{
					//sys.FileSystem.deleteFile(Sys.getCwd () + idString + "0.wav");
					//sys.FileSystem.deleteFile(Sys.getCwd () + idString + ".txt");
				    }
																}, null);
		}
	}


	
	/**
	 *  String for XSAMPA so that it can be pronounced by TTS
	 */
	public static function adaptedXSAMPAString(s:String):String
	{
		var adaptedText:String;
		adaptedText = "<prosody volume=\"x-loud\"><phoneme alphabet=\"x-microsoft-ups\" ph=" + "'" + "S1 "+ Phonetic_WindowsUPS.convertFromXSampa(s) + "'"+ "/></prosody>";
		return adaptedText;
	}
	
	/**
	 *  Check if supports XSAMPA
	 */
	
	public static function hasXSAMPASupport():Bool
	{
		return true;
	}
	
	/**
	*	TODO check if has TTS engine,if not propose to install
	*/
	public static function checkHasTTS():Void
	{
		#if (linux || android)
		T.checkHasTTS();
		#end
	}

	/**
	*   Set locale or language of TTS
	*/
	public static function setLanguageLocale(lang_variant:Int,lang:Int,lang_locale:String):Void
		
	{

		voice = "";
		var chosenOne:String = "";
		if ((lang_locale != null) && (lang_locale !=""))
		{
			chosenOne = lang_locale;
		} 
		else if (lang != 0) 
		{
			switch(lang)
			{
				case 0: chosenOne = "";
				case 1: chosenOne = "en";
				case 2: chosenOne = "fr";
				case 3: chosenOne = "de";
				case 4: chosenOne = "zh";
				case 5: chosenOne = "nl";
				case 6: chosenOne = "it";
				case 7: chosenOne = "ja";
				case 8: chosenOne = "es";
				case 9: chosenOne = "ru";
				case 10: chosenOne = "ko";
				case 11: chosenOne = "pl";
				case 12: chosenOne = "default";
				default: chosenOne = "";
			}
		}
		else
		{
			switch(lang_variant)
			{
				case 0: chosenOne = "";
				case 1: chosenOne = "en_US";
				case 2: chosenOne = "en_UK";
				case 3: chosenOne = "fr_FR";
				case 4: chosenOne = "de_DE";
				case 5: chosenOne = "zh_CN";
				case 6: chosenOne = "zh_TW";
				case 7: chosenOne = "nl_NL";
				case 8: chosenOne = "it_IT";
				case 9: chosenOne = "ja_JP";
				case 10: chosenOne = "es_ES";
				case 11: chosenOne = "ru_RU";
				case 12: chosenOne = "ko_KR";
				case 13: chosenOne = "pl_PL";
				case 14: chosenOne = "default";
				default: chosenOne = "";
			}
		}

		var lookForWord = "";
		if (chosenOne == "fr")
		{
			voice = "fr-FR";
		}
		else
		{
			voice = "en-GB";
		}
/*
		if (voice == "")
		{
			var voices = getInstalledEngines();
			trace("installed voices  " + voices);
			for (i in 0...voices.length)
			{
				if (voices[i].indexOf(lookForWord)!= -1)
				{
					voice = "" + i;
					trace("chosen Voice  :" + i);
					break;
				}
			} */
		//}

		
	}







	/**
	*	Set Pitch of TTS,1 is default
	*/
	public static function setPitch(f:Float):Void
	{
		#if (linux || android)
		T.setPitch(f);
		#end
	}

	/*
	*	Set Speech Rate of TTS,1 is default
	*/
	public static function setSpeechRate(f:Float):Void
	{
		#if (linux || android)
		T.setSpeechRate(f);
		#end
		
	}

	/**
	*   Checks if TTS is speaking
	*/
	public static function isSpeaking():Bool
	{
		#if (linux || android)
		return T.isSpeaking();
		#else
		trace("isSpeaking Flash");
		return false;
		#end
	}

	/**
	*	Check all available locale languages for initialised TTS engine
	*/
	public static function getLangAvailable(choice:Int):Array<Dynamic>
	{
		#if (linux || android)
		return T.getLangAvailable(choice);
		#else
		return ["en"];
		#end

	}

	/**
	*	Get actual language
	*/
	public static function getLang():String 
	{
		#if (linux || android)
		return T.getLang();
		#else
		return "en";
		#end
	}



	/**
	*	Check all installed engines
	*   
	*/
	public static function getInstalledEngines():Array<Dynamic>
	{
		return []; //no need anymore with ssml
		/*
		var cmd = Sys.getCwd () + "assets/tts.exe -V > voices.txt";  
    	Sys.command(cmd);  

    	var rawData:String = "";
				
		try {
			rawData = sys.io.File.getContent(Sys.getCwd () + "voices.txt");
		}    

		var voices:Array<String> = SPLIT_LINES.split(rawData);

		return voices;*/ 
		
	}

	/**
	*	Add Earcon,mapping between string of text and sound file
	*/
	public static function addEarcon(soundName:String,soundPath:String):Void
	{
		#if (linux || android)
		T.addEarcon(soundName,soundPath);
		#end
	}

	/**
	*	Adds earcon to queue
	*/
	public static function playEarcon(soundName:String):Void
	{
		#if (linux || android)
		T.playEarcon(soundName);
		#end
		
	}

	/**
	*
	*/
	public static function synthetiseToFile(text:String,location:Int,folder:String,filename:String):Void
	{
		#if (linux || android)
		T.synthetiseToFile(text,location,folder,filename);
		#end
	}

	public function new()
	{
	} 

    /**
	*	 shouter when TTS finished processing
	*/

	public static function finishedShouter(text:String)
	{
		setGameAttribute("TTSLastSaidId", text);
		TTS.tTSLastSaidId = text;
		shoutToScene("_customEvent_" + "TTSHasFinishedPlaying");
	}

 }
