
package com.stencyl.android;


import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.io.OutputStream;
import java.lang.reflect.Constructor;
import java.util.HashMap;

import org.haxe.lime.*;

import android.app.*;
import android.content.*;
import android.content.res.AssetManager;
import android.media.MediaPlayer;
import android.media.SoundPool;
import android.net.Uri;
import android.os.*;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.view.Window;
import android.view.WindowManager;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;

import android.widget.Toast;

import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnInitListener;
import android.speech.tts.UtteranceProgressListener;
import java.util.Locale;
import android.content.Intent;
import android.app.Activity;
import android.content.Context;
import android.os.Handler;
import org.haxe.lime.GameActivity;
import org.haxe.lime.HaxeObject;
import android.os.Bundle;
import android.util.Log;
import org.haxe.extension.Extension;
import org.haxe.lime.HaxeObject;

import java.util.*;

// For targetting different versions of android
import java.lang.reflect.InvocationTargetException;	
import java.lang.reflect.Method;
import java.lang.reflect.Type;

import android.os.Environment;	//for synthetise to file
import java.io.File;
import java.io.FileOutputStream; 

public class TTSAndroid extends Extension
{
	private static TTSAndroid instance;
	private static HaxeObject callback = null;										// Used for Haxe Callbacks
	static TextToSpeech mTts;		
	private static android.speech.tts.TextToSpeech.EngineInfo engineInfo;												// TTS instance
	//private static String s;
	private static String localeList = "";											// For getLanguage() callback
    private static String localeListDisplay = "";									// For getLanguage() callback
	private static Locale lang;														// Language set for TTS
	private static HashMap<String, String> map = new HashMap<String, String>();		// Map used for OnUtteranceCompletedListener
	private static String justFinishedText;											// Text that TTS has finished processing
	
	/**
	*	Start Engine with default language
	*/
	public static void startEngine(String engineName)
	{

		TextToSpeech.OnInitListener listener = new TextToSpeech.OnInitListener() 
		{
         	@Override
         	public void onInit(int status) 
			{
				if(status != TextToSpeech.ERROR) 
				{
					Log.i("TTSAndroid","initialised");
					//engineInfo = new android.speech.tts.TextToSpeech.EngineInfo();
					// If language is set, if it exists for TTS set language variant, else only set language, else default)
					if(lang != null)
					{
						if (mTts.isLanguageAvailable(lang) == TextToSpeech.LANG_COUNTRY_AVAILABLE)
						{
							mTts.setLanguage(lang);
						}
						else if (mTts.isLanguageAvailable(lang) == TextToSpeech.LANG_AVAILABLE)
						{
							mTts.setLanguage(new Locale(lang.getLanguage()));
						}
						else
						{
						mainActivity.runOnUiThread(
							new Runnable()
							{
								public void run()
									{
										Intent installIntent = new Intent();
										installIntent.setAction(TextToSpeech.Engine.ACTION_INSTALL_TTS_DATA);
										mainActivity.startActivity(installIntent);
										Toast.makeText(mainContext, "You must install the missing language", Toast.LENGTH_SHORT).show();
									}	 
							}
						);
						}
					}

         		}
      		}
			
		};

		if (android.os.Build.VERSION.SDK_INT <= 14)
		{
			mTts=new TextToSpeech(mainContext, listener);
		}
		else
		{
			mTts=new TextToSpeech(mainContext, listener, engineName);
		}
		
		
		// Set listener to the TTS engine   From Api 15
		if (android.os.Build.VERSION.SDK_INT <= 14)
		{
			mTts.setOnUtteranceCompletedListener(new TextToSpeech.OnUtteranceCompletedListener()
			{
				@Override
				public void onUtteranceCompleted (String utteranceId)
				{
					justFinishedText = utteranceId;
					Extension.mainActivity.runOnUiThread(
						new Runnable()
						{
							public void run()
							{
								callback.call("finishedShouter", new Object[] {justFinishedText});
							}	 
						}
					);
				
				}
			});
		}
		else
		{
			// Set listener to the TTS engine Till Api 15
			mTts.setOnUtteranceProgressListener(new UtteranceProgressListener()	
			{			
				@Override
				public void onDone(String utteranceId) 
				{
					justFinishedText = utteranceId;
					Extension.mainActivity.runOnUiThread(
						new Runnable()
						{
							public void run()
							{
								callback.call("finishedShouter", new Object[] {justFinishedText});
							}	 
						}
					);
				}

				@Override
				public void onError(String utteranceId) 
				{
				}

				@Override
				public void onStart(String utteranceId) 
				{
				}   
			});
		}
	}
	
	
	/**
	*	Close Engine
	*/
	public static void closeEngine()
	{
		if (mTts != null)
		{
			mTts.stop();
			mTts.shutdown();
			mTts 	= null;
		}
	}
	
	/**
	*	Stop engine talking
	*   TODO it seems you cannot do anything anymore afterwards, it seems pointless
	*/
	public static void stopEngine()
	{
		if (mTts != null)
		{
			mTts.stop();
		}
	}
	
		
	/**
	*	Check if mobile has TTS engine, if it has it initialise it, else ask it to download
	*/
	
	public static void checkHasTTS()
	{
		Intent checkIntent = new Intent();
		checkIntent.setAction(TextToSpeech.Engine.ACTION_CHECK_TTS_DATA);
		mainActivity.startActivityForResult(checkIntent, 0x01);
		
	}
	
	
	
	////// on Activity doesn't work, maybe because of single Task problem, maybe it could work on api 5 Lollipop
	@Override
	public boolean onActivityResult(int requestCode, int resultCode, Intent data) {
		Log.i("TTS", "Activity Result de ma classe à moi");
		if (requestCode == 0x01) {
			if (resultCode == TextToSpeech.Engine.CHECK_VOICE_DATA_PASS) {
				// Succès, au moins un moteur de TTS à été trouvé, on l'instancie
				// mTts = new TextToSpeech(mainContext, instance);
				Extension.mainActivity.runOnUiThread(
						new Runnable()
						{
							public void run()
							{
								callback.call("TTSLoadedShouter", new Object[] {});
							}	 
						}
					);
				return true;
			} else {
				// Echec, aucun moteur n'a été trouvé, on propose à l'utilisateur d'en installer un depuis le Market
				Intent installIntent = new Intent();
				installIntent.setAction(TextToSpeech.Engine.ACTION_INSTALL_TTS_DATA);
				Extension.mainActivity.startActivity(installIntent);
				return false;
			}
		}
		return super.onActivityResult(requestCode, resultCode, data);
	}
	
	/**
	*	Get Languages Available for TTS
	*	Engine must be turning
	*/
	public static void getLanguages()
	{
		Locale[] locales = Locale.getAvailableLocales();
		localeList = "";
		localeListDisplay = "";
		for (Locale locale : locales) 
		{
			int res = mTts.isLanguageAvailable(locale);
			if (res == TextToSpeech.LANG_COUNTRY_AVAILABLE) 	{
				localeList = localeList + ";" + locale.toString();
				localeListDisplay = localeListDisplay + ";" + locale.getDisplayName();
			}
		}
		Extension.mainActivity.runOnUiThread
		 (
				 new Runnable()
				 { 
					 public void run() 
					 {
						callback.call("langAvailable", new Object[] {localeList, localeListDisplay});
					 }
				 }
		 );
	}
	
	
	
	
	/**
	*	Setting Language Before Starting Engine
	*/
	public static void setLanguageAttempt(final HaxeObject callback, String language, String engineName)
	{
		TTSAndroid.callback = callback;
		
		if ((language == null)||(language == "")||(language == "default"))
		{
			lang = null;
		}
		else
		{
			Locale[] locales = Locale.getAvailableLocales();
			for (Locale item : locales)
			{
				if (item.toString().startsWith(language)) 
				{
					lang = item;
					break;
				}
			}
		}
		// Restarting Engine
		if (mTts != null)
		{
			mTts.stop();
			mTts.shutdown();
		}
		startEngine(engineName);
	}
	
	
	
	
	/**
	*	Say text.
	*	queueChoice = 0 : Flush
	*   queueChoice = 1 : Add
	*/
	public static void sayText(String textToSay, String idString, int queueChoice) {  
		String convertedText = textToSay; //charCodesToString(textToSay);
		// Compatibility : Change in api 21 Lollipop
		if (android.os.Build.VERSION.SDK_INT <= 21)
		{
			try 
			{
				map.put(TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID, idString);
				Method method = TextToSpeech.class.getMethod("speak", String.class, Integer.TYPE, HashMap.class );
				method.invoke(mTts, convertedText, queueChoice, map);    
			}
			catch (Exception e)
			{
			}
        } 
		else
		{
			try 
			{
				Bundle b = new Bundle();
				//b.putString(TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID, idString);
				Method method = TextToSpeech.class.getMethod("speak", CharSequence.class, Integer.TYPE, Bundle.class, String.class );
				method.invoke(mTts, convertedText, queueChoice, b, idString);
			}
			catch (Exception e)
			{
			}
		}
	}
	
	
	
	/**
	*   Converts charcodes back to a normal Java string
	*/
	public static String charCodesToString(String stringToConvert)
	{
		String finalText = "";
		List<String> charCodesList = Arrays.asList(stringToConvert.split("\\s*,\\s*"));
		for (String item : charCodesList) 
		{
			int i;
			i = Integer.parseInt(item); 
			char c = (char)i;
			finalText += c;
		}
		return finalText;
	}
		
		
	/** 
	*	To change speech rate 1 is the default value
	*/
	public static void changeSpeechRate(float speechRate)
	{
		mTts.setSpeechRate(speechRate);
	}
	
	/**
	*	To change pitch, 1 is the default value 
	*/
	public static void changePitch(float pitch)
	{
		mTts.setPitch(pitch);
	}

	
	/**
	 * 	Perform any final cleanup before an activity is destroyed.
	 */
	 @Override
	public void onDestroy () 
	{
		if (mTts != null)
		{
			mTts.stop();
			mTts.shutdown();
		}
		super.onDestroy();
	}
	
	
	/**
	*	To check if TTS is speaking
	*/
	public static boolean isTTSSpeaking()
	{
		return mTts.isSpeaking();
		/*
		Extension.mainActivity.runOnUiThread
		 (
				 new Runnable()
				 { 
					 public void run() 
					 {
						boolean result = mTts.isSpeaking();
						callback.call("isTTSSpeaking", new Object[] {result});
					 }
				 }
		 );
		 */
	}
	
	
	
	/**
	*	Setting Custom Earcon
	*/
	public static void addCustomEarcon(String soundName, String soundPath)
	{
		if (mTts != null)
		{
			if (android.os.Build.VERSION.SDK_INT <= 21)
			{
				try 
				{
				Method method = TextToSpeech.class.getMethod("addEarcon", String.class, String.class);
				method.invoke(mTts, soundName, soundPath);
				}
				catch (Exception e)
				{
				}
			} 
			else
			{
				try 
				{
				Method method = TextToSpeech.class.getMethod("addEarcon", String.class, File.class);
				//method.invoke(mTts, );
				}
				catch (Exception e)
				{
				}
		}
		}
	}
	
	/**
	*	Playing Custom Earcon
	*/
	public static void playCustomEarcon(String soundName)
	{
		if (mTts != null)
		{
			if (android.os.Build.VERSION.SDK_INT <= 21)
			{
				try 
				{
				Method method = TextToSpeech.class.getMethod("playEarcon", String.class, Integer.TYPE, HashMap.class);
				method.invoke(mTts, soundName, 1, null);
				}
				catch (Exception e)
				{
				}
			} 
			else
			{
				try 
				{
				Method method = TextToSpeech.class.getMethod("playEarcon", String.class, Integer.TYPE, Bundle.class, String.class);
				method.invoke(mTts, soundName, 1, null, null);
				}
				catch (Exception e)
				{
				}
		}
		}
	}
	


	/**
	*	Synthetise to file
	*/
	public static void synthToFile(String text, int loc, String folder, String filename)
	{
		// Creating File
		File output;
		File savePath;
	
		switch (loc)
		{
			case 0: savePath = mainContext.getFilesDir(); //Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOCUMENTS);      	// Default folder for documents
					break;
			case 1: savePath = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PODCASTS);  			// Default folder for podcasts
					break;
			case 2: savePath = mainContext.getFilesDir();  				// Local Directory
					break;
			case 3: savePath = mainContext.getCacheDir();  				//	Local Cache
					break;
			case 4: savePath = Environment.getExternalStorageDirectory(); 	// SD card
					break;
			default: savePath = mainContext.getCacheDir();
		}
		
		if ((folder != null)||!(folder.isEmpty()))
		{
			File folders = new File(savePath,folder);
			folders.mkdirs();
			savePath = folders;
		}
		output = new File(savePath,filename);

		// Synthetising text
		String convertedText = charCodesToString(text);
		// Compatibility : Change in api 21 Lollipop
		if (android.os.Build.VERSION.SDK_INT <= 21)
		{
			try 
			{
				map.put(TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID, convertedText);
				Method method = TextToSpeech.class.getMethod("synthesizeToFile", String.class, HashMap.class, String.class );
				method.invoke(mTts, convertedText, map, output.toString());    
			}
			catch (Exception e)
			{
			}
        } 
		else
		{
			try 
			{
				Bundle b = new Bundle();
				b.putString(TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID, convertedText);
				Method method = TextToSpeech.class.getMethod("synthesizeToFile", CharSequence.class, Bundle.class, File.class, String.class );
				method.invoke(mTts, convertedText, b, output, null);
			}
			catch (Exception e)
			{
			}
		}
	
	}
	

	/**
	 *  Get lang 
	 */
	
	public static String getLang()
	{
		if (android.os.Build.VERSION.SDK_INT < 21)
		{
			try 
			{
				Method method = TextToSpeech.class.getMethod("getLanguage");
				return method.invoke(mTts).toString();    
			}
			catch (Exception e)
			{
			}
        } 
		else
		{
			try 
			{
				Method method = TextToSpeech.class.getMethod("getVoice.getLocale");
				return method.invoke(mTts).toString();  
			}
			catch (Exception e)
			{
			}
		}

		return null;
	}


	/**
	*	TODO Get engines installed
	*
	*/
	public static String getInstalledEngines()//final HaxeObject callback)
	{
		List<TextToSpeech.EngineInfo> listInstalledEngines;
		listInstalledEngines = mTts.getEngines();
		List<String> listInstalledEnginesName;
		listInstalledEnginesName = new ArrayList<String>();
		String engines = "";
        for(int i = 0; i < listInstalledEngines.size(); i++)
		{
			listInstalledEnginesName.add(listInstalledEngines.get(i).name);
			engines = engines + ";" + listInstalledEngines.get(i).name;
        }	
		
		/*
		Extension.mainActivity.runOnUiThread
		 (
				 new Runnable()
				 { 
					 public void run() 
					 {
						callback.call("installedEngines", new Object[] {mTts.getEngines()});
					 }
				 }
		 );
		 */
		 return engines == null ? "" : engines;
	}


	public static String getDefaultEngine()
	{
		return  mTts.getDefaultEngine();
	} 
	
	/**
	*	TODO Create File with text to speech
	*	API4 / API 21 Lollipop    synthesizeToFile
	*/
	
	/**
	*	TODO get length in time of pronounced text 
	*	by creating file and getting the time
	*/
	

}
